!> @file
!> Author: Yang M. Wang
!> Date: April 2013
!> Calculates the expressions for the single fragment energy and pair fragment energies for MP2F12

!> General index convention:
!> *************************
!> a,b   : Virtual EOS
!> c,d,e : Virtual AOS
!> i,j   : Occupied EOS
!> k,l,m : Occupied AOS

module rif12_integrals_module 

#ifdef VAR_MPI   
  use infpar_module
  use lsmpi_type
  use lsmpi_bcast
  use lsmpi_reductionMod
#endif
  use,intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
  use precision
  use lstiming!, only: lstimer
  use screen_mod!, only: DECscreenITEM
  use dec_typedef_module
  use typedeftype!, only: Lsitem,lssetting
  use BUILDAOBATCH!,only:build_batchesofaos,determine_maxbatchorbitalsize,&
  !      & determine_MaxOrbitals
  use typedef!, only: typedef_free_setting,copy_setting
  use memory_handling
  use screen_mod!,only: free_decscreen, DECSCREENITEM
  use lsparameters
  use molecule_module
  use molecule_typetype
  use IntegralInterfaceMod!, only: II_getBatchOrbitalInfo
  use IntegralInterfaceDEC!, only: II_precalc_DECScreenMat,&

  !  use orbital_operations

  use ccintegrals!, only: get_full_AO_integrals,get_AO_hJ,get_AO_K,get_AO_Fock

  ! Patricks mat_transpose routine 
  use reorder_frontend_module!, only: mat_transpose(rows,column,pref1,A,pref2,AT)

  ! Thomas 
  use CABS_operations

  ! *********************************************
  !   DEC DEPENDENCIES (within deccc directory) 
  ! *********************************************
#ifdef VAR_MPI
  use decmpi_module !, only: mpi_communicate_mp2_int_and_amp
#endif

  ! Yangs F12 routines
  use decf12_routines_module
  use f12_routines_module
  use f12ri_util_module,only: GeneralTwo4CenterDECF12RICoef1112,&
       & GeneralTwo4CenterDECF12RICoef1223,&
       & DECF12RIB4,DECF12RIB4MPI,DECF12RIB5,DECF12RIB5MPI,&
       & DECF12RIB6,DECF12RIB6MPI,DECF12RIB7,DECF12RIB7MPI,&
       & DECF12RIB8,DECF12RIB8MPI,DECF12RIB9,DECF12RIB9MPI
  use f12ri_energycontraction_module
  use ri_util_module
  !#endif 


  use dec_fragment_utils!,only: calculate_fragment_memory, &
  !       & dec_simple_dgemm_update,start_flop_counter,&
  !       & get_currently_available_memory, atomic_fragment_free
  use array2_simple_operations!, only: array2_free, array2_extract_EOS, &
  !       & get_mp2_integral_transformation_matrices, get_mp2_integral_transformation_matrices_fc, &
  !      & extract_occupied_eos_mo_indices, extract_virtual_EOS_MO_indices,array2_init,array2_print
  use array4_simple_operations!, only: array4_delete_file, array4_init_file, &
  !       & array4_init_standard, array4_free, array4_reorder, array4_init, &
  !       & array4_contract1, array4_open_file, array4_write_file_type2, &
  !       & array4_close_file, array4_write_file_type1, mat_transpose, &
  !     & array4_read_file_type2

  public :: get_rif12_fragment_energy

  private

contains

  !> Brief: Gives the single and pair fragment energy for RI-MP2-F12
  !> Author: Yang M. Wang
  !> Date: April 2015
  subroutine get_rif12_fragment_energy(MyFragment, Taibj, Tai, fragcase, Fragment1, Fragment2)
    implicit none

    !> Atomic fragment to be determined (Single or Pair fragment)
    type(decfrag), intent(inout) :: MyFragment
    !> t2EOS amplitudes stored in the order T(a,i,b,j)
    real(realk), intent(in), pointer :: Taibj(:,:,:,:) 
    !> t1EOS amplitudes stored in the order T(a,i)
    real(realk), intent(in), pointer :: Tai(:,:) 
    !> Case MODEL
    integer :: fragcase
    !> Fragment 1 in the pair fragment
    type(decfrag),intent(in), optional :: Fragment1
    !> Fragment 2 in the pair fragment
    type(decfrag),intent(in), optional :: Fragment2

    !========================================================
    !   Allocating integer space sizes
    !========================================================
    !> Logical variable to check if this is a pair fragment
    logical :: dopair
    !Pairfragment
    logical,pointer :: dopair_occ(:,:)
    !> number of AO orbitals
    integer :: nbasis
    !> number of occupied MO orbitals in EOS 
    integer :: noccEOS, nvirtAOS
    !> number of occupied MO orbitals in AOS 
    integer :: noccAOS
    !> number of occupied MO orbitals in AOS tot 
    integer :: noccAOStot
    !> number of occupied MO + virtual MO orbitals in AOS 
    integer :: nocvAOS
    !> number of CABS AO orbitals
    integer :: ncabsAO
    !> number of CABS MO orbitals
    integer :: ncabsMO

    !> MO coefficient matrix for the CABS MOs
    real(realk), pointer :: CMO_CABS(:,:)
    !> MO coefficient matrix for the RI MOs
    real(realk), pointer :: CMO_RI(:,:)

    !> TMP 
    integer :: ix, iy, i, j, m, n, k, l, p, q, c, r, s, t, a, b
    real(realk) :: E_21, E_21C, E_22, E_23, E_F12
    real(realk) :: E_MP2F12_geminal,E_CCSDF12, EVa,EVb,EVc
    real(realk) :: tmp, energy, tmp2
    real(realk) :: temp
    real(realk) :: rimp2_energy,ccsd_energy
    real(realk) :: f12_energy
    !========================================================
    !  Additional variables
    !========================================================
    real(realk),pointer :: gmo(:,:,:,:)
    real(realk),pointer :: gao(:,:,:,:)
    real(realk),pointer :: Fac(:,:)
    real(realk),pointer :: Fpp(:,:)
    real(realk) :: eps

    !========================================================
    ! Additional variables
    !========================================================
    real(realk),pointer :: CoEOS(:,:)
    real(realk),pointer :: CoAOS(:,:)
    real(realk),pointer :: CoAOStot(:,:)
    real(realk),pointer :: CvAOS(:,:)
    !> MO coefficient matrix for the OCC + VIRT
    real(realk),pointer :: Cfull(:,:)
    real(realk),pointer :: Fkj(:,:)
    real(realk),pointer :: Fab(:,:)
    real(realk),pointer :: Fnm(:,:)

    !Handling of doapir 
    integer :: noccpair,noccpairnoperm
    integer,pointer :: Kval(:,:),KVALnoperm(:,:)
    !========================================================
    !  RI variables
    !========================================================
    real(realk),pointer :: CalphaR(:),CalphaG(:),CalphaF(:),CalphaD(:),CalphaCvirt(:),CalphaCocc(:)
    real(realk),pointer :: CalphaP(:), CalphaCoccT(:),CalphaX(:)
    real(realk),pointer :: CalphaGeos(:),CalphaGcabsMOeos(:)
    real(realk),pointer :: CalphaRcabsMO(:),CalphaGcabsAO(:),CalphaCcabsT(:)
    real(realk),pointer :: CalphaGcabsMO(:),CalphaXcabsAO(:),CalphaXcabsAO2(:)
    real(realk),pointer :: ABdecompR(:,:),ABdecompG(:,:)
    real(realk),pointer :: ABdecompF(:,:),Umat(:,:),Rtilde(:,:),ABdecompX(:,:),ABdecompX2(:,:)
    real(realk),pointer :: CalphaTmp(:),CalphaTmp2(:),CalphaTmp3(:)

    logical :: ABdecompCreateR,ABdecompCreateG,ABdecompCreateF,ABdecompCreateX2
    logical :: FORCEPRINT,use_bg_buf,LS,ABdecompCreateX

    character :: intspec(5)
    real(realk) :: TS,TE,TS2,TE2
    real(realk) :: ExchangeF12V1,CoulombF12V1
    real(realk) :: CoulombF12X1,ExchangeF12X1 
    real(realk) :: EV1,EV2,EV3,EV4,EC1C2,EX1,EX2,EX3,EX4
    real(realk) :: EV1a,EV2a,EV3a,EV4a,EC1a2a
    real(realk) :: EV1b,EV2b,EV3b,EV4b
    real(realk) :: EV1c,EV2c,EV3c,EV4c
    real(realk) :: EV1d,EV2d,EV3d,EV4d

    real(realk) :: EB1,EB2,EB3,EB4,EB5,EB6,EB7,EB8,EB9
    integer :: lupri,offsetI,offsetJ

    !> Lsitem structure
    !type(lsitem) :: mylsitem

    !> Timings
    real(realk) :: tcpu,twall
    logical :: Collaborate,DoBasis
    integer :: n1,n2,n3,n4,Tain1,Tain2

    !> bat
    type(mp2_batch_construction) :: bat

    !> Number of Auxilliary Basis functions
    integer :: NBA, NBA2
    !> MPI related variables
    integer(kind=ls_mpik) :: node,numnodes
    integer :: mynum
    logical :: wakeslaves, master
    !> Indexing
    integer :: nAtoms,naux,natomsAux,MinAuxBatch 
    !> Frozen core
    integer :: offset
    !> Special treatment of Aux
    integer(kind=long) :: nSize,nsize1,nsize2,nsize3
    logical :: ChangedDefault,DoPrint,FORCEPRINTRI,do1122,doX2,doX3X4
    integer :: oldAOdfAux, oldAORegular, nbasis2
    TYPE(MoleculeInfo),pointer :: molecule4,molecule3

    !========================================================
    !  MPI related stuff
    !========================================================
    integer,pointer :: nAuxMPI(:)
    integer :: AuxMPIstartMy,iAuxMPIextraMy,AuxMPIstartMPI,iAuxMPIextraMPI
    integer :: numnodesstd,ncabsonly,nbasisfull,nAtomsAuxT,nAuxT
    real(realk),pointer :: UmatTmp(:,:)
    real(realk) :: factor, EV2tmp, EX2tmp, EV3tmp, EV4tmp, EX3tmp, EX4tmp
    real(realk) :: EV2atmp, EV3atmp, EV4atmp, EV2btmp, EV3btmp, EV4btmp
    real(realk) :: EV2ctmp, EV3ctmp, EV4ctmp,EJ,EK
    real(realk),pointer :: CalphaMPI(:),CalphaMPI2(:)
    logical :: SavesameMol(4,4),TensorTiling3C,DoCCSD,NOMOTRANSVIRT
    integer(kind=8) :: memF12,MaxMemF12
#ifdef VAR_MPI
    real(realk) :: lsmpibufferRIF12(34)
    integer :: inode,nbuf1

    lsmpibufferRIF12=0.0E0_realk
#endif
    do1122=.FALSE.
    doX2=.FALSE.
    IF(DECinfo%FullCabsAtomicExtent)THEN
       SavesameMol = MyFragment%Mylsitem%setting%sameMol
    ENDIF
    !mylsitem = MyFragment%MyLsitem
    NOMOTRANSVIRT = .FALSE.
    MaxMemF12=0
    memF12 = 0
    DoCCSD = fragcase.EQ.MODEL_CCSD
    use_bg_buf = .FALSE. !FIXME 
    DoPrint = DECinfo%PL.GT.1.OR.DECinfo%F12debug
    lupri = DECinfo%output
    FORCEPRINTRI = .FALSE.
#ifdef VAR_TIME
    FORCEPRINT = .TRUE.
#else
    FORCEPRINT = .FALSE.
#endif    
    call LSTIMER('START DEC-RIMP2-F12: ',TS,TE,DECinfo%output,ForcePrint)

#ifdef VAR_MPI
    master= (infpar%lg_mynum == infpar%master)
    mynum = infpar%lg_mynum
    numnodes = infpar%lg_nodtot
    wakeslaves = infpar%lg_nodtot.GT.1
    if(.NOT.master)lupri = 6
#else
    ! If MPI is not used, consider the single node to be "master"
    master=.true.
    mynum = 0
    numnodes = 1
    wakeslaves = .false.
#endif
    numnodesstd = numnodes
    call LSTIMER('START ',TS2,TE2,DECinfo%output,ForcePrint)

    !========================================================
    !  Init stuff
    !========================================================
    TensorTiling3C = .FALSE. 
    f12_energy = 0.0E0_realk 

    natoms    = MyFragment%natoms
    nbasis    = MyFragment%nbasis

    nvirtAOS  = MyFragment%nvirtAOS
    noccEOS   = MyFragment%noccEOS
    noccAOS   = MyFragment%noccAOS

    !noccfull  = noccEOS
    ! For frozen core: noccAOS in only valence. But
    ! noccAOStot is core+valence, and nocvAOStot is core+valence+virtual,
    ! both with and without frozen core.
    noccAOStot = MyFragment%nocctot  !core + valens
    nocvAOS = noccAOStot + nvirtAOS

    ! Offset: Used for frozen core
    if(DECinfo%frozencore) then
       offset = MyFragment%ncore
    else
       offset = 0
    end if

    ncabsAO = size(MyFragment%Ccabs,1)    
    ncabsMO = size(MyFragment%Ccabs,2)

    nbasis2 = 0
    natomsaux = 0
    naux = 0
    !    E_21C = 0.0E0_realk

    !IF(DECinfo%frozencore)call lsquit('DEC RI-/MP2-F12 frozen core not implemented',-1)

    !========================================================
    !  Special treatment of Aux
    !========================================================
    call determine_maxBatchOrbitalsize(DECinfo%output,MyFragment%mylsitem%SETTING,MinAuxBatch,'D')

    IF(DECinfo%FullAuxAtomicExtent)THEN
       call getMolecularDimensions(MyFragment%mylsitem%INPUT%AUXMOLECULE,nAtomsAux,nBasis2,nAux)
    ELSE
       call getMolecularDimensions(MyFragment%mylsitem%SETTING%MOLECULE(1)%p,nAtomsAux,nBasis2,nAux)
       if(natoms.NE.natomsAux)call lsquit('Error in DEC RIMP2F12 natoms dim mismatch',-1)
    ENDIF

    IF(nAux.EQ.0)THEN
       WRITE(DECinfo%output,'(1X,A)')'DEC RIMP2F12 MEM: Warning no Aux basis have been chosen for RIMP2, Using Regular'
       ChangedDefault = .TRUE.
       call get_default_AOs(oldAORegular,oldAOdfAux) !the current values for Regular and Aux Basis 
       call set_default_AOs(oldAORegular,oldAORegular) !change to use Regular for Aux 
       call getMolecularDimensions(MyFragment%mylsitem%SETTING%MOLECULE(1)%p,nAtoms,nBasis2,nAux)
    ENDIF

    IF(nAux.EQ.0)THEN
       WRITE(DECinfo%output,'(1X,A)')'DEC RIMP2F12 MEM: Warning no Aux basis have been chosen for RIMP2, Using Regular'
       ChangedDefault = .TRUE.
       call get_default_AOs(oldAORegular,oldAOdfAux) !the current values for Regular and Aux Basis 
       call set_default_AOs(oldAORegular,oldAORegular) !change to use Regular for Aux 
       call getMolecularDimensions(MyFragment%mylsitem%SETTING%MOLECULE(1)%p,nAtoms,nBasis2,nAux)
    ENDIF

    !========================================================
    !  Sanity Check if we do the pair calculation
    !========================================================
    if((present(Fragment1) .AND. (.NOT. present(Fragment2))) .OR. &
         & (present(Fragment2) .AND. (.NOT. present(Fragment1)))) then
       call lsquit("get_f12_fragment_energy: Missing optional arguments Fragment1 and Fragment2")
    endif

    dopair = .FALSE.
    if(present(Fragment1) .AND. present(Fragment2)) then
       dopair = .TRUE.
    endif

    ! ***********************************************************
    !   Constructing Coefficient matrices 
    ! ***********************************************************   
    if(DECinfo%F12debug .and. master) then
       print *, "-------------------------------------------------"
       print *, "     F12-integrals.F90                           "
       print *, "-------------------------------------------------"
       print *, "nbasis:       ", nbasis
       print *, "noccEOS:      ", noccEOS
       print *, "nvirtAOS:     ", nvirtAOS
       print *, "-------------------------------------------------"
       print *, "noccAOS       ", noccAOS 
       print *, "noccAOStot    ", noccAOStot
       print *, "ncabsAO       ", ncabsAO
       print *, "ncabsMO       ", ncabsMO
       print *, "-------------------------------------------------"
    end if

    ! Creating a CoccEOS matrix 
    call mem_alloc(CoEOS, nbasis, noccEOS)
    do i=1, noccEOS
       ix = MyFragment%idxo(i)
       CoEOS(:,i) = MyFragment%Co(:,ix)
    end do

    ! Creating a CoccAOS matrix (always core+valence, also for frozen core)
    call mem_alloc(CoAOS, nbasis, noccAOS)
    ! Only for frozen core: Include core MOs explicitly
    ! (without frozen core: core MOs are included in MyFragment%Co already)
    do i=1, MyFragment%noccAOS
       CoAOS(:,i) = MyFragment%Co(:,i)
    end do

    call mem_alloc(CoAOStot, nbasis, noccAOStot)
    do i=1,offset
       CoAOStot(:,i) = MyFragment%CoreMO(:,i)
    end do
    do i=1, MyFragment%noccAOS
       CoAOStot(:,i+offset) = MyFragment%Co(:,i)
    end do

    ! Creating a CvirtAOS matrix 
    call mem_alloc(CvAOS, nbasis, nvirtAOS)
    do i=1, nvirtAOS
       CvAOS(:,i) = MyFragment%Cv(:,i)
    end do

    ! ***********************************************************
    ! Creating the F matrix 
    ! ***********************************************************
    ! Creating a Fkj MO matrix occ EOS
    call mem_alloc(Fkj, noccAOS, noccEOS)
    Fkj = 0E0_realk
    do j=1, noccEOS
       iy = MyFragment%idxo(j)
       Fkj(:,j) = MyFragment%ppfock(:,iy)
    end do
    ! Note that Fkj contains only valence orbitals since F(core,valence)=0.
    !========================================================
    !  Creating Coeff-matrices 
    !========================================================
    call mem_alloc(CMO_Cabs, ncabsAO, ncabsMO)
    do i=1, ncabsMO
       CMO_Cabs(:,i) = MyFragment%Ccabs(:,i)
    end do
    call mem_alloc(CMO_RI, ncabsAO, ncabsAO)
    do i=1, ncabsAO
       CMO_RI(:,i) = MyFragment%Cri(:,i)
    end do

    ! Creating a CocvAOStot matrix 
    call mem_alloc(Cfull, nbasis, nocvAOS)
    do i=1,noccAOStot
       Cfull(:,i) = CoAOStot(:,i)
    end do
    do i=1,nvirtAOS
       Cfull(:,i+noccAOStot) = MyFragment%Cv(:,i)
    end do

    call mem_alloc(Fac, nvirtAOS, ncabsMO)
    do a=1, nvirtAOS
       do c=1, ncabsMO
          Fac(a,c) = Myfragment%Fcp(c,a+noccAOStot)
       enddo
    enddo

    !Slow implementation can be done with 2dgemms in B6
    call mem_alloc(Fpp,nvirtAOS+noccAOStot,nvirtAOS+noccAOStot)
    Fpp = 0.0E0_realk
    do p=1,offset
       do q=1,offset
          Fpp(p,q) = MyFragment%ccfock(p,q)
       enddo
    enddo

    do p=1+offset, noccAOStot
       do q=1+offset, noccAOStot
          Fpp(p,q) = MyFragment%ppfock(p-offset,q-offset)
       enddo
    enddo

    do p=noccAOStot+1, nvirtAOS+noccAOStot
       do q=noccAOStot+1, nvirtAOS+noccAOStot
          Fpp(p,q) = MyFragment%qqfock(p-noccAOStot,q-noccAOStot)
       enddo
    enddo

    call mem_alloc(Fnm,noccAOStot,noccAOStot)
    Fnm = 0.0E0_realk
    do n=1,offset
       do m=1,offset
          Fnm(n,m) = MyFragment%ccfock(n,m)
       enddo
    enddo
    do n=1+offset, noccAOStot
       do m=1+offset, noccAOStot
          Fnm(n,m) = MyFragment%ppfock(n-offset,m-offset)
       enddo
    enddo

    !=================================================================
    != Step 0: Creating of dopair_occ                                =
    !=================================================================

#ifdef VAR_MPI

    !=================================================================
    != Step 1: Wake up the slaves                                    =
    !=================================================================

    call mem_alloc(dopair_occ,noccEOS,noccEOS)

    if(master) then
       if(dopair) then
          call which_pairs_occ(Fragment1,Fragment2,MyFragment,dopair_occ)
       else
          dopair_occ = .TRUE.
       endif
    endif

    if(wakeslaves .and. master) then
       call ls_mpibcast(DECRIMP2F12,infpar%master,infpar%lg_comm)
       IF(DoCCSD)THEN
          call mpi_communicate_MyFragment_f12(MyFragment,Taibj,fragcase,dopair,Tai)
       ELSE
          call mpi_communicate_MyFragment_f12(MyFragment,Taibj,fragcase,dopair)
       ENDIF
    endif

    if(wakeslaves) then
       call ls_mpibcast(dopair_occ,noccEOS,noccEOS,infpar%master,infpar%lg_comm)
    endif

    IF(wakeslaves)THEN
       call mem_alloc(nAuxMPI,numnodes)
       IF(TensorTiling3C)THEN
          call lsquit('TensorTiling3C not implemented',-1)
       ELSE
          call BuildnAuxMPIUsedRI(nAux,numnodesstd,nAuxMPI)
       ENDIF
    ELSE
       call mem_alloc(nAuxMPI,1)
       nAuxMPI(1) = nAux
    ENDIF

#else

    call mem_alloc(dopair_occ,noccEOS,noccEOS)
    dopair_occ = .FALSE.
    if(dopair) then
       call which_pairs_occ(Fragment1,Fragment2,MyFragment,dopair_occ)
    else
       dopair_occ = .TRUE.
    endif
    call mem_alloc(nAuxMPI,1)
    nAuxMPI(1) = nAux

#endif

!    call BuildFullKval(Kvalnoperm,noccEOS,Kval,noccpair)
    call BuildKval(dopair_occ,noccEOS,Kval,noccpair,dopair,KVALnoperm,noccpairnoperm)

    !=================================================================
    != Step 2:  Calculate energy contributions                       =
    !=================================================================

    !normally I do not like to allocate things at the beginning but 
    !due to an analysis of memory heap performance and the 
    !background buffer features of ordered allocations this is beneficial
    call mem_alloc(ABdecompR,nAux,nAux)
    call mem_alloc(ABdecompF,nAux,nAux)
    call mem_alloc(ABdecompX,nAux,nAux)
    call mem_alloc(ABdecompG,nAux,nAux)
    ABdecompCreateF = .TRUE.
    ABdecompCreateX = .TRUE.
    ABdecompCreateR = .TRUE.
    ABdecompCreateG = .TRUE.
    nullify(CalphaX) !a if(associated(CalphaX)) is used in the code
    !just in case
    nullify(CalphaF)
    nullify(CalphaR)
    nullify(CalphaD)
    nullify(CalphaXcabsAO)
    nullify(CalphaG)
    nullify(CalphaGcabsMO)
    nullify(CalphaRcabsMO)
    nullify(CalphaGcabsAO)

    IF(.NOT.DECinfo%NaturalLinearScalingF12TermsV1)THEN
       ! Calculate the Fitting Coefficients (alpha|F|ij)
       intspec(1) = 'D' !Auxuliary DF AO basis function on center 1 (2 empty)
       intspec(2) = 'R' !Regular AO basis function on center 3
       intspec(3) = 'R' !Regular AO basis function on center 4
       intspec(4) = 'F' !The Gaussian geminal divided by the Coulomb operator g/r12 (GGemCouOperator)
       intspec(5) = 'F' !The Gaussian geminal divided by the Coulomb operator g/r12 (GGemCouOperator)
       !Unique; CalphaF(noccEOS,noccEOS)
       call Build_CalphaMO2(MyFragment%MyLsitem,master,nbasis,nbasis,nAux,LUPRI,&
            & FORCEPRINTRI,wakeslaves,CoEOS,noccEOS,CoEOS,noccEOS,&
            & mynum,numnodesstd,CalphaF,NBA,ABdecompF,ABdecompCreateF,intspec,&
            & use_bg_buf,TensorTiling3C,NOMOTRANSVIRT)
       call LSTIMER('DECRIMP2F12:CalphaF',TS2,TE2,DECinfo%output,ForcePrint)
       ABdecompCreateF = .FALSE.
       call F12RIUTILSingle(NBA,noccEOS,noccEOS,CalphaF,KVAL,noccpair,EJ,EK)
       EV1 = -((5.0E0_realk*0.25E0_realk)*EJ-EK*0.25E0_realk)
       IF(use_bg_buf)THEN
          call mem_pseudo_dealloc(CalphaF)
       ELSE
          call mem_dealloc(CalphaF)
       ENDIF      
       call LSTIMER('DECRIMP2F12:V1',TS2,TE2,DECinfo%output,ForcePrint)       
    ELSE
       EV1 = 0.0E0_realk
    ENDIF
#ifdef VAR_MPI 
    lsmpibufferRIF12(2)=EV1
#endif                

    !================================================================
    ! No Fitting Coefficients allocated 
    !================================================================

    intspec(1) = 'D' !Auxuliary DF AO basis function on center 1 (2 empty)
    intspec(2) = 'C' !CABS AO basis function on center 3
    intspec(3) = 'R' !Regular AO basis function on center 4
    intspec(4) = '2' !The f12 Operator
    intspec(5) = '2' !The f12 Operator
    !Unique: CalphaXcabsAO(NBA,ncabsAO,noccAOS) 
    NOMOTRANSVIRT = .TRUE.
    call Build_CalphaMO2(MyFragment%MyLsitem,master,ncabsAO,nbasis,nAux,LUPRI,&
         & FORCEPRINTRI,wakeslaves,CMO_RI,ncabsAO,CoAOS,noccAOS,&
         & mynum,numnodesstd,CalphaTmp,NBA,ABdecompX,ABdecompCreateX,&
         & intspec,use_bg_buf,TensorTiling3C,NOMOTRANSVIRT)
    memF12 = memF12+NBA*ncabsAO*noccAOS
    call LSTIMER('FULLRIMP2 F12:CalphaXcabsAO',TS2,TE2,DECinfo%output,ForcePrint)
    ABdecompCreateX = .FALSE.
    NOMOTRANSVIRT = .FALSE.
    
    !Build CalphaXcabsAO(NBA,ncabsRI,noccEOS) 
    !==============================================================
    nsize = NBA*ncabsAO*noccEOS
    memF12 = memF12+NBA*ncabsAO*noccEOS
    MaxMemF12=MAX(MaxMemF12,memF12)
    call mem_alloc(CalphaXcabsAO,nsize,'DECF12:CalphaXcabsAO')
    !Transform CABS AO to CABS RI index
    M = NBA     !Rows of Output Matrix  
    N = ncabsAO !Columns of Output Matrix 
    K = ncabsAO !summation dimension 
    do i=1, noccEOS
       ix = MyFragment%idxo(i)
       offsetI = 1+(I-1)*NBA*ncabsAO  !EOS index 
       offsetJ = 1+(Ix-1)*NBA*ncabsAO !AOS index 
       !CalphaTmp2(NBA,ncabsAO,noccAOS)
       call DGEMM('N','N',M,N,K,1.0E0_realk,CalphaTmp(offsetJ),M,CMO_RI,K,&
            & 0.0E0_realk,CalphaXcabsAO(offsetI),M) 
    enddo

    !Build CalphaTmp2(NBA,nbasis,noccAOS)
    nsize = NBA*nbasis*noccAOS
    memF12 = memF12+NBA*nbasis*noccAOS
    MaxMemF12=MAX(MaxMemF12,memF12)
    call mem_alloc(CalphaTmp2,nsize,'DECF12:CalphaTmp2 X')
    !memF12 = NBA*ncabsAO*(noccAOS+noccEOS)+NBA*nbasis*noccAOS
    call extractSub3dim(CalphaTmp,nBA,ncabsAO,noccAOS,CalphaTmp2,nBA,nbasis,noccAOS,&
         & 1,NBA,1,nbasis,1,noccAOS)
    memF12 = memF12-size(CalphaTmp,kind=8)
    call mem_dealloc(CalphaTmp)
    !memF12 = NBA*ncabsAO*noccEOS+NBA*nbasis*noccAOS = NBA*(ncabsAO*noccEOS+nbasis*noccAOS)

    !Build CalphaTmp(NBA,noccEOS,noccAOS)
    nsize = NBA*noccEOS*noccAOS
    memF12 = memF12+NBA*noccEOS*noccAOS
    MaxMemF12=MAX(MaxMemF12,memF12)
    call mem_alloc(CalphaTmp,nsize)
    !memF12 = NBA*(ncabsAO*noccEOS+nbasis*noccAOS+noccEOS*noccAOS)
    M = NBA    !Rows of Output Matrix  
    N = noccEOS   !Columns of Output Matrix 
    K = nbasis !summation dimension 
    !CalphaTmp(NBA,noccEOS,noccAOS)=CalphaTmp2(NBA,nbasis,noccAOS)*CoEOS(nbasis,noccEOS)
    do i=1, noccAOS
       offsetI = 1+(I-1)*NBA*noccEOS
       offsetJ = 1+(I-1)*NBA*nbasis 
       call DGEMM('N','N',M,N,K,1.0E0_realk,CalphaTmp2(offsetJ),M,CoEOS,K,&
            & 0.0E0_realk,CalphaTmp(offsetI),M) 
    enddo
    memF12 = memF12-size(CalphaTmp2)
    call mem_dealloc(CalphaTmp2)
    !memF12 = NBA*(ncabsAO*noccEOS+noccEOS*noccAOS)

    IF(.NOT.DECinfo%NaturalLinearScalingF12TermsX1)THEN
       !Build CalphaTmp2(NBA,noccEOS,noccEOS)=CalphaTmp(NBA,noccEOS,noccAOS)*Fkj(noccAOS,noccEOS)
       !==============================================================
       nsize = NBA*noccEOS*noccEOS
       memF12 = memF12+NBA*noccEOS*noccEOS
       MaxMemF12=MAX(MaxMemF12,memF12)
       call mem_alloc(CalphaTmp2,nsize,'RIMP2F12:CalphaT X1')
       !memF12 = NBA*(ncabsAO*noccEOS+noccEOS*noccAOS+noccEOS*noccEOS)
       M = NBA*noccEOS         !rows of Output Matrix
       N = noccEOS             !columns of Output Matrix
       K = noccAOS             !summation dimension    
       call dgemm('N','N',M,N,K,1.0E0_realk,CalphaTmp,M,Fkj,K,0.0E0_realk,CalphaTmp2,M)
    ENDIF

    !Build CalphaX(NBA,noccEOS,noccEOS) <= CalphaTmp(nBA,noccEOS,noccAOS)
    !==============================================================
    nsize = NBA*noccEOS*noccEOS
    memF12 = memF12+NBA*noccEOS*noccEOS
    MaxMemF12=MAX(MaxMemF12,memF12)
    call mem_alloc(CalphaX,nsize)
    !memF12 = NBA*(ncabsAO*noccEOS+noccEOS*noccAOS+2*noccEOS*noccEOS)
    call extractSub3dimAOS2EOS(CalphaTmp,nBA,noccEOS,CalphaX,NBA,noccEOS,&
         & 1,NBA,1,noccEOS,MyFragment%idxo,noccEOS,noccAOS)
    memF12 = memF12-size(CalphaTmp)
    call mem_dealloc(CalphaTmp)
    !memF12 = NBA*(ncabsAO*noccEOS+2*noccEOS*noccEOS)

    !==============================================================
    !=  X1: Eq. A12 in JCP 144 204112
    !==============================================================

    IF(.NOT.DECinfo%NaturalLinearScalingF12TermsX1)THEN
       call F12RIUTILSingle2(NBA,noccEOS,noccEOS,CalphaX,CalphaTmp2,KVAL,noccpair,EJ,EK)
       memF12 = memF12-size(CalphaTmp2)
       call mem_dealloc(CalphaTmp2)
       !memF12 = NBA*(ncabsAO*noccEOS+noccEOS*noccEOS)
       !minus is due to the overall minus from equation (41) and (42) due to
       !contribution from the \bar{B}_{ij}^{ij}
       EX1 = -1.0E0_realk*(0.21875E0_realk*EJ + 0.03125E0_realk*EK)
       call LSTIMER('DECRIMP2F12:X1',TS2,TE2,DECinfo%output,ForcePrint)       
    ELSE
       EX1 = 0.0E0_realk
    ENDIF
#ifdef VAR_MPI 
    lsmpibufferRIF12(3)=EX1
#endif

    !==============================================================
    !=  B2 and B3: Eq. A25 and A26 in JCP 144 204112
    !==============================================================

    call F12UTIL_B2B3(nBA,CalphaXcabsAO,ncabsAO,noccEOS,CalphaX,noccEOS,noccEOS,&
         & MyFragment%hJir,Kval,noccpair,EB2,EB3)
    memF12 = memF12-size(CalphaXcabsAO)
    call mem_dealloc(CalphaXcabsAO)
    memF12 = memF12-size(CalphaX)
    call mem_dealloc(CalphaX)
    !memF12 = 0
    call LSTIMER('DECRIMP2F12:B2B3',TS2,TE2,DECinfo%output,ForcePrint)       
#ifdef VAR_MPI 
    lsmpibufferRIF12(4)=EB2       !we need to perform a MPI reduction at the end 
    lsmpibufferRIF12(5)=EB3       !we need to perform a MPI reduction at the end 
#endif

    !================================================================
    ! No Fitting Coefficients allocated 
    print*,'X memF12',memF12,'MaxMemF12',MaxMemF12*8E-9_realk,' GB'
    !================================================================

    !Build Generalized CalphaTmp2 = Galpha(NBA,ncabsAOpure,noccAOS) 
    intspec(1) = 'D' !Auxuliary DF AO basis function on center 1 (2 empty)
    intspec(2) = 'C' !CABS AO basis function on center 3
    intspec(3) = 'R' !Regular AO basis function on center 4
    intspec(4) = 'G' !The f12 Operator
    intspec(5) = 'G' !The f12 Operator
    !Unique: CalphaGcabsAO(NBA,ncabsAO,noccAOS) 
    NOMOTRANSVIRT = .TRUE.
    call Build_CalphaMO2(MyFragment%mylsitem,master,ncabsAO,nbasis,nAux,LUPRI,&
         & FORCEPRINTRI,wakeslaves,CMO_RI,ncabsAO,CoAOS,noccAOS,&
         & mynum,numnodesstd,CalphaTmp2,NBA,ABdecompG,ABdecompCreateG,&
         & intspec,use_bg_buf,TensorTiling3C,NOMOTRANSVIRT)
    call LSTIMER('DECRIMP2F12:CalphaGcabsAO',TS2,TE2,DECinfo%output,ForcePrint)
    ABdecompCreateG = .FALSE.
    NOMOTRANSVIRT = .FALSE.
    memF12 = memF12+NBA*ncabsAO*noccAOS
    MaxMemF12=MAX(MaxMemF12,memF12)

    !Build CalphaGcabsAO(NBA,ncabsAO,noccEOS) 
    nsize = NBA*ncabsAO*noccEOS
    call mem_alloc(CalphaGcabsAO,nsize)
    M = NBA     !Rows of Output Matrix  
    N = ncabsAO !Columns of Output Matrix 
    K = ncabsAO !summation dimension 
    do i=1, noccEOS
       ix = MyFragment%idxo(i)
       offsetI = 1+(Ix-1)*NBA*ncabsAO !AOS index
       offsetJ = 1+(I-1)*NBA*ncabsAO  !EOS index
       !CalphaGcabsAO(NBA,ncabsAO,noccEOS) = CalphaTmp2(NBA,ncabsAO,noccAOS)*CMO_RI(ncabsAO,ncabsAO)
       call DGEMM('N','N',M,N,K,1.0E0_realk,CalphaTmp2(offsetI),M,CMO_RI,&
            & K,0.0E0_realk,CalphaGcabsAO(offsetJ),M) 
    enddo

    !Build CalphaGcabsMO(NBA,ncabsMO,noccAOS)
    nsize = NBA*ncabsMO*noccAOS
    call mem_alloc(CalphaGcabsMO,nsize)
    !Transform Regular AO to MO index
    M = NBA       !Rows of Output Matrix  
    N = ncabsMO   !Columns of Output Matrix 
    K = ncabsAO   !summation dimension 
    do i=1, noccAOS
       offsetI = 1+(I-1)*NBA*ncabsAO !AOS index
       offsetJ = 1+(I-1)*NBA*ncabsMO
       call DGEMM('N','N',M,N,K,1.0E0_realk,CalphaTmp2(offsetI),M,CMO_CABS,&
            & K,0.0E0_realk,CalphaGcabsMO(offsetJ),M) 
    enddo

    !Build CalphaG(NBA,nocvAOS,noccAOS)
    nsize = NBA*nbasis*noccAOS
    call mem_alloc(CalphaTmp,nsize)
    call extractSub3dim(CalphaTmp2,nBA,ncabsAO,noccAOS,CalphaTmp,nBA,nbasis,noccAOS,&
         & 1,NBA,1,nbasis,1,noccAOS)
    call mem_dealloc(CalphaTmp2)
    nsize = NBA*nocvAOS*noccAOS
    call mem_alloc(CalphaG,nsize)
    !Transform Regular AO to MO index
    M = NBA    !Rows of Output Matrix  
    N = nocvAOS   !Columns of Output Matrix 
    K = nbasis !summation dimension 
    do i=1, noccAOS
       offsetI = 1+(I-1)*NBA*nocvAOS
       offsetJ = 1+(I-1)*NBA*nbasis 
       call DGEMM('N','N',M,N,K,1.0E0_realk,CalphaTmp(offsetJ),M,Cfull,&
            & K,0.0E0_realk,CalphaG(offsetI),M) 
    enddo
    call mem_dealloc(CalphaTmp)

    !==============================================================
    !=  B4:  Eq. A27 in JCP 144, 204112                           =
    !==============================================================
    !CalphaTmp3(nBA,ncabsAO,noccEOS)=Krr(ncabsAO,ncabsAO)*CalphaGcabsAO(NBA,ncabsAO,noccEOS) 
    nsize = nBA*ncabsAO*noccEOS
    call mem_alloc(CalphaTmp3,nsize)
    M = NBA     !Rows of Output Matrix  
    N = ncabsAO !Columns of Output Matrix 
    K = ncabsAO !summation dimension 
    do i=1, noccEOS
       ix = MyFragment%idxo(i)
       offsetI = 1+(Ix-1)*NBA*ncabsAO !AOS index
       offsetJ = 1+(I-1)*NBA*ncabsAO  !EOS index
       !CalphaTmp3(NBA,ncabsAO,noccEOS) = CalphaGcabsAO(NBA,ncabsAO,noccEOS)*Krr(ncabsAO,ncabsAO)
       call dgemm('N','N',m,n,k,1.0E0_realk,CalphaGcabsAO(offsetJ),m,MyFragment%Krs,&
            & K,0.0E0_realk,CalphaTmp3(offsetJ),m)
    enddo
    call F12RIUTILCoef1112(nBA,CalphaGcabsAO,ncabsAO,noccEOS,CalphaTmp3,ncabsAO,noccEOS,&
         & EB4,0,0,wakeslaves,use_bg_buf,numnodesstd,nAuxMPI,mynum,KVAL,noccpair,do1122,doX2)
    call mem_dealloc(CalphaTmp3)
    call LSTIMER('DECRIMP2F12:B4',TS2,TE2,DECinfo%output,ForcePrint)       

#ifdef VAR_MPI
    lsmpibufferRIF12(13)=EB4      !we need to perform a MPI reduction at the end 
#endif

    !==============================================================
    !=  B5:  Eq. A28 in JCP 144, 204112                           =
    !==============================================================    
    !CalphaTmp3(nBA,ncabsAO,noccEOS)=Frr(ncabsAO,ncabsAO)*CalphaGcabsAO(NBA,ncabsAO,noccEOS) 
    nsize = nBA*ncabsAO*noccEOS
    call mem_alloc(CalphaTmp3,nsize)
    M = NBA     !Rows of Output Matrix  
    N = ncabsAO !Columns of Output Matrix 
    K = ncabsAO !summation dimension 
    do I=1,noccEOS
       offsetI = 1 + (I-1)*nba*ncabsAO
       call dgemm('N','N',m,n,k,1.0E0_realk,CalphaGcabsAO(offsetI),m,MyFragment%Frs,k,&
            & 0.0E0_realk,CalphaTmp3(offsetI),m)
    enddo       
    !CalphaTmp(nBA,noccAOStot,noccEOS) <= CalphaG(nBA,nocvAOS,noccAOS)
    nsize = nBA*noccAOStot*noccEOS
    call mem_alloc(CalphaTmp,nsize)
    call extractSub3dimAOS2EOS(CalphaG,nBA,nocvAOS,CalphaTmp,nBA,noccAOStot,&
         & 1,NBA,1,noccAOStot,MyFragment%idxo,noccEOS,noccAOS)
    call F12RIUTILCoef1232(nBA,CalphaTmp3,ncabsAO,noccEOS,CalphaTmp,noccAOStot,noccEOS,&
         & CalphaGcabsAO,ncabsAO,noccEOS,EB5,0,0,wakeslaves,use_bg_buf,numnodesstd,&
         & nAuxMPI,mynum,KVAL,noccpair)
    EB5 = 0.5E0_realk*EB5
    call mem_dealloc(CalphaTmp)
    call mem_dealloc(CalphaTmp3)
    call LSTIMER('DECRIMP2F12:B5',TS2,TE2,DECinfo%output,ForcePrint)       

#ifdef VAR_MPI
    lsmpibufferRIF12(14)=EB5      !we need to perform a MPI reduction at the end 
#endif

    !==============================================================
    !=  B8:  Eq. A31 in JCP 144, 204112                           =
    !==============================================================
    
    nsize = nBA*noccAOStot*noccEOS
    call mem_alloc(CalphaTmp3,nsize)       
    !CalphaTmp3(nba,noccAOStot,noccEOS) = CalphaGcabsAO(nba,ncabsAO,noccAOS)*F(ncabsAO,noccAOStot)
    m =  nBA
    k =  ncabsAO   
    n =  noccAOStot      
    do I=1,noccEOS
       ix = MyFragment%idxo(i)
       offsetI = 1 + (Ix-1)*nba*ncabsAO    !AOS index
       offsetJ = 1 + (I-1)*nba*noccAOStot  !EOS index
       call dgemm('N','N',m,n,k,1.0E0_realk,CalphaGcabsAO(offsetI),m,MyFragment%Frm,k,&
            & 0.0E0_realk,CalphaTmp3(offsetJ),m)
    enddo
    call mem_dealloc(CalphaGcabsAO)

    nsize = nBA*noccAOStot*noccEOS
    call mem_alloc(CalphaTmp,nsize)
    !CalphaTmp(nBA,noccAOStot,noccEOS) <= CalphaG(nBA,nocvAOS,noccAOS)
    call extractSub3dimAOS2EOS(CalphaG,nBA,nocvAOS,CalphaTmp,nBA,noccAOStot,&
         & 1,NBA,1,noccAOStot,MyFragment%idxo,noccEOS,noccAOS)

    call mem_alloc(CalphaTmp2,nBA*ncabsMO*noccEOS)
    call extractSub3dimAOS2EOS(CalphaGcabsMO,nBA,ncabsMO,CalphaTmp2,nBA,ncabsMO,&
         & 1,NBA,1,ncabsMO,MyFragment%idxo,noccEOS,noccAOS)

    call F12RIUTILCoef1232(nBA,CalphaTmp,noccAOStot,noccEOS,CalphaTmp2,ncabsMO,noccEOS,&
         & CalphaTmp3,noccAOStot,noccEOS,EB8,0,0,wakeslaves,use_bg_buf,numnodesstd,nAuxMPI,&
         & mynum,KVAL,noccpair)
    call mem_dealloc(CalphaTmp)
    call mem_dealloc(CalphaTmp2)
    call mem_dealloc(CalphaTmp3)
    call LSTIMER('DECRIMP2F12:B8',TS2,TE2,DECinfo%output,ForcePrint)       
#ifdef VAR_MPI
    lsmpibufferRIF12(18)=EB8      !we need to perform a MPI reduction at the end 
#endif

    !==============================================================
    !=  X2:  Eq. A13 in JCP 144, 204112                           =
    !==============================================================
    nsize = NBA*nocvAOS*noccEOS
    call mem_alloc(CalphaTmp3,nsize)               ! G_qj = C_qk B_kj 
    !CalphaTmp3(NBA,nocvAOS,noccEOS) = CalphaG(NBA,nocvAOS,noccAOS)*F(noccAOS,noccEOS)
    M = nocvAOS*NBA         !rows of Output Matrix
    N = noccEOS             !columns of Output Matrix
    K = noccAOS             !summation dimension
    call dgemm('N','N',M,N,K,1.0E0_realk,CalphaG,M,Fkj,K,0.0E0_realk,CalphaTmp3,M)
    doX2=.TRUE.
    nsize = nBA*nocvAOS*noccEOS
    call mem_alloc(CalphaTmp,nsize)
    call extractSub3dimAOS2EOS(CalphaG,nBA,nocvAOS,CalphaTmp,nBA,nocvAOS,&
         & 1,NBA,1,nocvAOS,MyFragment%idxo,noccEOS,noccAOS)
    call F12RIUTILCoef1112(nBA,CalphaTmp,nocvAOS,noccEOS,CalphaTmp3,nocvAOS,noccEOS,&
         & EX2,0,0,wakeslaves,use_bg_buf,numnodesstd,nAuxMPI,mynum,KVAL,noccpair,do1122,doX2)
    doX2=.FALSE.     
    call mem_dealloc(CalphaTmp)
    call mem_dealloc(CalphaTmp3)
    call LSTIMER('DECRIMP2F12:X2',TS2,TE2,DECinfo%output,ForcePrint)       
#ifdef VAR_MPI 
    lsmpibufferRIF12(7)=EX2      !we need to perform a MPI reduction at the end 
#endif

    !==============================================================
    !=  X3 and X4:  Eq. A14 and A15 in JCP 144, 204112            =
    !==============================================================

    !Build CalphaTmp2(NBA,cabsMO,noccEOS) = CalphaGcabsMO(NBA,ncabsMO,noccAOS)*Fkj(noccAOS,noccEOS)
    nsize = NBA*ncabsMO*noccEOS
    call mem_alloc(CalphaTmp2,nsize)
    M = NBA*ncabsMO !rows of Output Matrix
    N = noccEOS     !columns of Output Matrix
    K = noccAOS     !summation dimension
    !CalphaTmp2(NBA,cabsMO,noccEOS) = CalphaGcabsMO(NBA,ncabsMO,noccAOS)*Fkj(noccAOS,noccEOS)
    call dgemm('N','N',M,N,K,1.0E0_realk,CalphaGcabsMO,M,Fkj,K,0.0E0_realk,CalphaTmp2,M)

    call mem_alloc(CalphaGcabsMOeos,nBA*ncabsMO*noccEOS,'F12:CalphaGcabsMOeos')
    call extractSub3dimAOS2EOS(CalphaGcabsMO,nBA,ncabsMO,CalphaGcabsMOeos,nBA,ncabsMO,&
         & 1,NBA,1,ncabsMO,MyFragment%idxo,noccEOS,noccAOS)
    call mem_dealloc(CalphaGcabsMO)

    !Build CalphaTmp3(nBA,noccAOStot,noccAOS) <= CalphaG(nBA,nocvAOS,noccAOS)
    nsize = NBA*noccAOStot*noccAOS
    call mem_alloc(CalphaTmp3,nsize)
    call extractSub3dim(CalphaG,nBA,nocvAOS,noccAOS,CalphaTmp3,nBA,noccAOStot,noccAOS,&
         & 1,NBA,1,noccAOStot,1,noccAOS)
    !Build CalphaTmp(nBA,noccAOStot,noccEOS) = CalphaTmp3(nBA,noccAOStot,noccAOS)*Fkj(noccAOS,noccEOS)
    nsize = NBA*noccAOStot*noccEOS
    call mem_alloc(CalphaTmp,nsize)
    M = NBA*noccAOStot   !rows of Output Matrix
    N = noccEOS          !columns of Output Matrix
    K = noccAOS          !summation dimension
    call dgemm('N','N',M,N,K,1.0E0_realk,CalphaTmp3,M,Fkj,K,0.0E0_realk,CalphaTmp,M)
    call mem_dealloc(CalphaTmp3)

    call mem_alloc(CalphaGeos,nBA*nocvAOS*noccEOS,'F12:CalphaGeos')
    call extractSub3dimAOS2EOS(CalphaG,nBA,nocvAOS,CalphaGeos,nBA,nocvAOS,&
         & 1,NBA,1,nocvAOS,MyFragment%idxo,noccEOS,noccAOS)
    call mem_dealloc(CalphaG)

    call mem_alloc(CalphaTmp3,nBA*noccAOStot*noccEOS)
    call extractSub3dim(CalphaGeos,nBA,nocvAOS,noccEOS,CalphaTmp3,nBA,noccAOStot,&
         & noccEOS,1,NBA,1,noccAOStot,1,noccEOS)
    doX3X4=.TRUE.
    !Note deactivating permutational symmetry
    call F12RIUTILCoef1234(nBA,CalphaTmp3,noccAOStot,noccEOS,CalphaGcabsMOeos,ncabsMO,noccEOS,&
         & CalphaTmp,noccAOStot,noccEOS,CalphaTmp2,ncabsMO,noccEOS,EX3,EX4,0,0,wakeslaves,&
         & use_bg_buf,numnodesstd,nAuxMPI,mynum,KVALnoperm,noccpairnoperm,doX3X4)
    doX3X4=.FALSE.
    call mem_dealloc(CalphaTmp)
    call mem_dealloc(CalphaTmp2)
    call mem_dealloc(CalphaTmp3)
    call LSTIMER('DECRIMP2F12:X3X4',TS2,TE2,DECinfo%output,ForcePrint)       
#ifdef VAR_MPI
    lsmpibufferRIF12(11)=EX3      !we need to perform a MPI reduction at the end 
    lsmpibufferRIF12(12)=EX4      !we need to perform a MPI reduction at the end 
#endif

    !Currently allocated CalphaGeos(NBA,nocvAOS,noccEOS),CalphaGcabsMOeos(NBA,ncabsMO,noccEOS)

    !==============================================================
    !=  B7:  Eq. A30 in JCP 144, 204112                           =
    !==============================================================
    
    nsize = nBA*noccAOStot*noccEOS
    call mem_alloc(CalphaTmp3,nsize)
    m =  nBA
    k =  noccAOStot
    n =  noccAOStot
    do i=1,noccEOS
       j=1+(i-1)*NBA*nocvAOS   
       l=1+(i-1)*NBA*noccAOStot 
       !CalphaTmp3(nBA,noccAOStot,noccEOS)=CalphaGeos(NBA,1:noccAOStot,noccEOS)*Fmm(noccAOStot,noccAOStot)
       call dgemm('N','N',m,n,k,1.0E0_realk,CalphaGeos(j),m,Fnm,k,0.0E0_realk,CalphaTmp3(l),m)
    enddo
    nsize = nBA*noccAOStot*noccEOS
    call mem_alloc(CalphaTmp,nsize)
    !CalphaTmp(nBA,noccAOStot,noccEOS) <= CalphaGeos(nBA,nocvAOS,noccEOS)
    call extractSub3dim(CalphaGeos,nBA,nocvAOS,noccEOS,CalphaTmp,nBA,noccAOStot,noccEOS,&
         & 1,NBA,1,noccAOStot,1,noccEOS)
    call F12RIUTILCoef1232(nBA,CalphaTmp3,noccAOStot,noccEOS,CalphaGcabsMOeos,ncabsMO,noccEOS,&
         & CalphaTmp,noccAOStot,noccEOS,EB7,0,0,wakeslaves,use_bg_buf,numnodesstd,&
         & nAuxMPI,mynum,KVAL,noccpair)
    EB7 = -EB7/2.0E0_realk
    call mem_dealloc(CalphaTmp)      
    call mem_dealloc(CalphaTmp3)
    call LSTIMER('DECRIMP2F12:B7',TS2,TE2,DECinfo%output,ForcePrint)       
#ifdef VAR_MPI
    lsmpibufferRIF12(17)=EB7      !we need to perform a MPI reduction at the end 
#endif

    !==============================================================
    !=  B9:  Eq. A32 in JCP 144, 204112                           =
    !==============================================================
    
    nsize = nBA*nocvAOS*noccEOS
    call mem_alloc(CalphaTmp3,nsize)
    m =  nBA
    k =  ncabsMO   
    n =  nocvAOS        
    do i=1,noccEOS
       offsetI = 1 + (I-1)*nba*ncabsMO 
       offsetJ = 1 + (I-1)*nba*nocvAOS
       !CalphaTmp3(nba,nocvAOS,noccEOS) = CalphaGcabsMOeos(nba,ncabsMO,noccEOS)*F(ncabsMO,nocvAOS)
       call dgemm('N','N',m,n,k,1.0E0_realk,CalphaGcabsMOeos(offsetI),m,MyFragment%Fcp,k,&
            & 0.0E0_realk,CalphaTmp3(offsetJ),m)
    enddo
    call F12RIUTILCoef1112(nBA,CalphaGeos,nocvAOS,noccEOS,CalphaTmp3,nocvAOS,noccEOS,&
         & EB9,noccAOStot,0,wakeslaves,use_bg_buf,numnodesstd,nAuxMPI,mynum,KVAL,noccpair,do1122,doX2)
    EB9 = -2.0E0_realk*EB9
    call mem_dealloc(CalphaTmp3)
    call LSTIMER('DECRIMP2F12:B9',TS2,TE2,DECinfo%output,ForcePrint)       
#ifdef VAR_MPI
    lsmpibufferRIF12(19)=EB9      !we need to perform a MPI reduction at the end 
#endif

    !Currently allocated: CalphaGcabsMOeos,CalphaGeos (both small)

    intspec(1) = 'D' !Auxuliary DF AO basis function on center 1 (2 empty)
    intspec(2) = 'C' !CABS AO basis function on center 4
    intspec(3) = 'R' !Regular AO basis function on center 3
    intspec(4) = 'C' !The Coulomb Operator
    intspec(5) = 'C' !The Coulomb Operator
    !Unique: CalphaRcabsAO(NBA,ncabsAO,nocc)
    NOMOTRANSVIRT = .TRUE.
    call Build_CalphaMO2(MyFragment%mylsitem,master,ncabsAO,nbasis,nAux,LUPRI,&
         & FORCEPRINTRI,wakeslaves,CMO_RI,ncabsAO,CoEOS,noccEOS,& 
         & mynum,numnodesstd,CalphaTmp2,NBA,ABdecompR,ABdecompCreateR,&
         & intspec,use_bg_buf,TensorTiling3C,NOMOTRANSVIRT)
    NOMOTRANSVIRT = .FALSE.
    call LSTIMER('DECRIMP2F12:CalphaRcabsAO',TS2,TE2,DECinfo%output,ForcePrint)
    ABdecompCreateR = .FALSE.
       
    !BuildCalphaRcabsMO
    nsize = NBA*ncabsMO*noccEOS
    call mem_alloc(CalphaRcabsMO,nsize)
    !Transform Regular AO to MO index
    M = NBA       !Rows of Output Matrix  
    N = ncabsMO   !Columns of Output Matrix 
    K = ncabsAO   !summation dimension 
    do I=1,noccEOS
       offsetI = 1+(I-1)*NBA*ncabsAO
       offsetJ = 1+(I-1)*NBA*ncabsMO
       call DGEMM('N','N',M,N,K,1.0E0_realk,CalphaTmp2(offsetI),M,CMO_CABS,&
            & K,0.0E0_realk,CalphaRcabsMO(offsetJ),M) 
    enddo
       
    !Build CalphaR
    nsize = NBA*nbasis*noccEOS
    call mem_alloc(CalphaTmp,nsize)
    call extractSub3dim(CalphaTmp2,nBA,ncabsAO,noccEOS,CalphaTmp,nBA,nbasis,noccEOS,&
         & 1,NBA,1,nbasis,1,noccEOS)
    call mem_dealloc(CalphaTmp2)
    nsize = NBA*nocvAOS*noccEOS
    call mem_alloc(CalphaR,nsize)
    !Transform Regular AO to MO index
    M = NBA    !Rows of Output Matrix  
    N = nocvAOS   !Columns of Output Matrix 
    K = nbasis !summation dimension 
    do I=1,noccEOS
       offsetI = 1+(I-1)*NBA*nocvAOS
       offsetJ = 1+(I-1)*NBA*nbasis
       call DGEMM('N','N',M,N,K,1.0E0_realk,CalphaTmp(offsetJ),M,Cfull,&
            & K,0.0E0_realk,CalphaR(offsetI),M) 
    enddo
    call mem_dealloc(CalphaTmp)

    !==============================================================
    !=  V3 and V4:  Eq. 37 and 38 in JCP 144, 204112              =
    !==============================================================
    !V3V4
    nsize = nBA*noccAOStot*noccEOS
    call mem_alloc(CalphaTmp,nsize)
    !CalphaTmp(nBA,noccAOStot,noccEOS) <= CalphaR(nBA,nocvAOS,noccEOS)
    call extractSub3dim(CalphaR,nBA,nocvAOS,noccEOS,CalphaTmp,nBA,noccAOStot,noccEOS,&
         & 1,NBA,1,noccAOStot,1,noccEOS)
    nsize = nBA*noccAOStot*noccEOS
    call mem_alloc(CalphaTmp2,nsize)
    call extractSub3dim(CalphaGeos,nBA,nocvAOS,noccEOS,CalphaTmp2,nBA,noccAOStot,noccEOS,&
         & 1,NBA,1,noccAOStot,1,noccEOS)
    call F12RIUTILCoef1234(nBA,CalphaTmp,noccAOStot,noccEOS,CalphaRcabsMO,ncabsMO,noccEOS,&
         & CalphaTmp2,noccAOStot,noccEOS,CalphaGcabsMOeos,ncabsMO,noccEOS,EV3,EV4,0,0,wakeslaves,&
         & use_bg_buf,numnodesstd,nAuxMPI,mynum,KVAL,noccpair,doX3X4)
    EV3 = EV3/2.0E0_realk
    EV4 = EV4/2.0E0_realk
    call mem_dealloc(CalphaTmp)
    call mem_dealloc(CalphaTmp2)
    call mem_dealloc(CalphaRcabsMO)
    call LSTIMER('DECRIMP2F12:V3V4',TS2,TE2,DECinfo%output,ForcePrint)       
#ifdef VAR_MPI
    lsmpibufferRIF12(8)=EV3      !we need to perform a MPI reduction at the end 
    lsmpibufferRIF12(9)=EV4      !we need to perform a MPI reduction at the end 
#endif

    if(.NOT. DoCCSD) then 
       !==================================================================
       !=  C1 and C2:  Eq. A3 and A4 in JCP 144, 204112                  =
       !=  This term is not needed for CCSD - a different version is used=
       !=  This term requires doubles amplitudes                         = 
       !==================================================================
       ! Using Laplace transform this should be done like
       ! Caibj = (Gcibj*Fac + Gcjai*Fcb)*Taibj 
       !       = Gcibj*Fac*Taibj + Gcjai*Fcb*Taibj 
       !       = [Fac*(ci|G|alpha)](alpha|bj)*(ai|gmod|beta)(beta|gmod|bj)
       !       + second term     
       ! (beta|gmod|bj) is the modified laplace fitting coefficients
       ! For now do it stupidly 
       nsize = nBA*nvirtAOS*noccEOS
       call mem_alloc(CalphaTmp3, nsize)
       !CalphaTmp3(NBA,nvirt,noccEOS)=CalphaGcabsMOeos(NBA,ncabsMO,noccEOS)*F(cabsMO,nvirt)
       m = NBA
       k = ncabsMO
       n = nvirtAOS
       DO I=1,noccEOS
          OFFSETI=1+(I-1)*NBA*nvirtAOS
          OFFSETJ=1+(I-1)*NBA*ncabsMO 
          call dgemm('N','T',m,n,k,1.0E0_realk,CalphaGcabsMOeos(OFFSETJ),m,&
               & Fac,n,0.0E0_realk,CalphaTmp3(OFFSETI),m)
       ENDDO
       call mem_dealloc(CalphaGcabsMOeos)
       nullify(CalphaGcabsMOeos)

       nsize = nBA*nvirtAOS*noccEOS
       call mem_alloc(CalphaTmp,nsize)
       call extractSub3dim(CalphaGeos,nBA,nocvAOS,noccEOS,CalphaTmp,nBA,nvirtAOS,noccEOS,&
            & 1,NBA,noccAOStot+1,nocvAOS,1,noccEOS)
       call F12RIUTIL_MP2F12_C1C2_dec(nBA,noccEOS,nvirtAOS,&
            & CalphaTmp,CalphaTmp3,Taibj,EC1C2,Kval,noccpair,dopair_occ)
       call mem_dealloc(CalphaTmp)
       call mem_dealloc(CalphaTmp3)
       call LSTIMER('DECRIMP2F12:C1C2',TS2,TE2,DECinfo%output,ForcePrint)       
    ELSE
       EC1C2=0.0E0_realk
       call mem_dealloc(CalphaGcabsMOeos)
       nullify(CalphaGcabsMOeos)
    ENDIF
#ifdef VAR_MPI 
    lsmpibufferRIF12(10)=EC1C2
#endif

    !Currently allocated CalphaGeos,CalphaR

    !==============================================================
    !=  V2:  Eq. 36 in JCP 144, 204112                            =
    !==============================================================
    do1122 = .TRUE. 
    call F12RIUTILCoef1112(nBA,CalphaR,nocvAOS,noccEOS,CalphaGeos,nocvAOS,noccEOS,&
         & EV2,0,0,wakeslaves,use_bg_buf,numnodesstd,nAuxMPI,mynum,KVAL,&
         & noccpair,do1122,doX2)
    do1122 = .FALSE. 
    call LSTIMER('DECRIMP2F12:V2',TS2,TE2,DECinfo%output,ForcePrint)       
#ifdef VAR_MPI 
    lsmpibufferRIF12(6)=EV2      !we need to perform a MPI reduction at the end 
#endif

    !==============================================================
    !=  B6:  Eq. A29 in JCP 144, 204112                           =
    !==============================================================
    
    nsize = nBA*nocvAOS*noccEOS
    call mem_alloc(CalphaTmp3,nsize)
    m =  nBA
    k =  nocvAOS
    n =  nocvAOS
    !CalphaTmp3(NBA,nocvAOS,noccEOS) = CalphaGeos(NBA,nocvAOS,noccEOS)*Fpp(nocvAOS,nocvAOS)
    do i=1,noccEOS
       j=1+(i-1)*NBA*nocvAOS
       call dgemm('N','N',m,n,k,1.0E0_realk,CalphaGeos(j),m,Fpp,k,0.0E0_realk,CalphaTmp3(j),m)
    enddo
    call F12RIUTILCoef1112(nBA,CalphaGeos,nocvAOS,noccEOS,CalphaTmp3,nocvAOS,noccEOS,&
         & EB6,noccAOStot,0,wakeslaves,use_bg_buf,numnodesstd,nAuxMPI,mynum,KVAL,noccpair,do1122,doX2)
    EB6 = -1.0E0_realk*EB6
    call mem_dealloc(CalphaTmp3)
    call LSTIMER('DECRIMP2F12:B6',TS2,TE2,DECinfo%output,ForcePrint)       
#ifdef VAR_MPI 
    lsmpibufferRIF12(15)=EB6      !we need to perform a MPI reduction at the end 
#endif
    call mem_dealloc(CalphaGeos)

    !Currently allocated CalphaGes,CalphaR

    IF(DECinfo%NaturalLinearScalingF12TermsB1)THEN
       EB1 = 0.0E0_realk
    ELSE
       !==============================================================
       !=  B1: Eq. A24 in JCP 144 204112
       !==============================================================
       
       !Calculate the Fitting Coefficients (alpha|[[T,g],g]|ij) 
       intspec(1) = 'D' !Auxuliary DF AO basis function on center 1 (2 empty)
       intspec(2) = 'R' !Regular AO basis function on center 3
       intspec(3) = 'R' !Regular AO basis function on center 4
       intspec(4) = 'D' !The double commutator [[T,g],g] 
       intspec(5) = 'C' !The metric operator = Regular Coulomb operator 1/r12
       !Build the R coefficient of Eq. 90 of J Comput Chem 32: 2492–2513, 2011
       !Unique: CalphaD(NBA,nocc,nocc)
       call Build_CalphaMO2(MyFragment%mylsitem,master,nbasis,nbasis,nAux,LUPRI,&
            & FORCEPRINTRI,wakeslaves,CoEOS,noccEOS,CoEOS,noccEOS,&
            & mynum,numnodesstd,CalphaD,NBA,ABdecompR,ABdecompCreateR,&
            & intspec,use_bg_buf,TensorTiling3C,NOMOTRANSVIRT)
       call LSTIMER('FULLRIMP2 F12:CalphaD',TS2,TE2,DECinfo%output,ForcePrint)
       ABdecompCreateR=.FALSE.

       !Build the U matrix in Eq. 88 of J Comput Chem 32: 2492–2513, 2011
       call mem_alloc(Umat,nAux,nAux)
       !perform this suborutine on the GPU (Async)
       call Build_RobustERImatU(MyFragment%mylsitem,master,nAux,LUPRI,&
            & FORCEPRINTRI,wakeslaves,mynum,numnodesstd,ABdecompR,'D',Umat)
       
       !Build the R tilde coefficient of Eq. 89 of J Comput Chem 32: 2492–2513, 2011
       nsize = nBA*noccEOS*noccEOS
       call mem_alloc(CalphaTmp,nsize)
       !offset = ncore
       !CalphaTmp(NBA,noccAO,noccEOS) = CalphaR(NBA,ncore+1:noccAOStot,noccEOS)
!       call extractSub3dim(CalphaR,nBA,nocvAOS,noccEOS,CalphaTmp,nBA,noccAOS,noccEOS,&
!            & 1,NBA,offset+1,offset+noccAOStot,1,noccEOS)
       !CalphaTmp(NBA,noccEOS,noccEOS) <= CalphaR(NBA,nocvAOS,noccEOS)
       call extractSub3dimSpecial(CalphaR,nBA,nocvAOS,noccEOS,CalphaTmp,MyFragment%idxo,offset)
#ifdef VAR_MPI
       !Build the R tilde coefficient of Eq. 89 of J Comput Chem 32: 2492–2513, 2011
       call BuildF12RtildeCoef(Umat,nAux,CalphaTmp,NBA,noccEOS*noccEOS,CalphaD,wakeslaves,&
            & TensorTiling3C,numnodesstd,mynum,numnodes,nAuxMPI,use_bg_buf)
#else
       !CalphaD(NBA,nocc,nocc) = -0.5*Umat(NBA,NBA)*CalphaTmp(NBA,nocc,nocc)+CalphaD(NBA,nocc,nocc)
       M = NBA          !rows of Output Matrix
       K = NBA          !summation dimension
       N = noccEOS*noccEOS    !columns of Output Matrix
       call dgemm('N','N',M,N,K,1.0E0_realk,Umat,M,CalphaTmp,K,-0.5E0_realk,CalphaD,M)
#endif
       call mem_dealloc(Umat)         
       !CalphaD is now the R tilde coefficient of Eq. 89 of J Comput Chem 32: 2492–2513, 2011
       call F12RIUTILSingle2(NBA,noccEOS,noccEOS,CalphaD,CalphaTmp,Kval,noccpair,EJ,EK)
       call mem_dealloc(CalphaTmp)
       call mem_dealloc(CalphaD)
       EB1 = (7.0E0_realk/32.0E0_realk)*EJ + (1.0E0_realk/32.0E0_realk)*EK
       call LSTIMER('DECRIMP2F12:EB1',TS2,TE2,DECinfo%output,ForcePrint)   
    ENDIF
#ifdef VAR_MPI 
       lsmpibufferRIF12(1)=EB1
#endif         
    
    call mem_dealloc(CalphaR)

    if(DoCCSD) then

       !==============================================================
       !=                                                            =
       != Implementation of CCSD(2)_R12                              =
       !=                                                            =
       !==============================================================

       intspec(1) = 'D' !Auxuliary DF AO basis function on center 1 (2 empty)
       intspec(2) = 'R' !Regular AO basis function on center 3
       intspec(3) = 'R' !Regular AO basis function on center 4
       intspec(4) = 'F' !The Gaussian geminal divided by the Coulomb operator g/r12 (GGemCouOperator)
       intspec(5) = 'F' !The Gaussian geminal divided by the Coulomb operator g/r12 (GGemCouOperator)

       call Build_CalphaMO2(MyFragment%Mylsitem,master,nbasis,nbasis,nAux,LUPRI,FORCEPRINT, &
       & wakeslaves,CoEOS,noccEOS,Cfull,nocvAOS,mynum,numnodesstd,CalphaF,NBA,ABdecompF,&
       & ABdecompCreateF,intspec,use_bg_buf,TensorTiling3C,NOMOTRANSVIRT)
       ABdecompCreateF = .FALSE.

       !==============================================================
       != Term v1a: Vij^ab_v1a = Fijab                               =
       !==============================================================
       call F12RIUTIL_CCSDF12_V1a(NBA,noccEOS,nvirtAOS,nocvAOS,noccAOStot,CalphaF,Taibj,&
            & EV1a,Kval,noccpair)
       call LSTIMER('DEC-RICCSD(2)_/F12 V1a: ',TS2,TE2,DECinfo%output,ForcePrint)
#ifdef VAR_MPI 
       lsmpibufferRIF12(21)=EV1a
#endif         

       !==============================================================
       != Term v1b: Vij^ia_1b = Fijia                                =
       !==============================================================
       call F12RIUTIL_CCSDF12_V1b(nBA,offset,noccEOS,nvirtAOS,nocvAOS,noccAOStot,CalphaF,&
            & Tai,EV1b)
       call mem_dealloc(CalphaF)
       call LSTIMER('DEC-RICCSD(2)_/F12 V1b: ',TS2,TE2,DECinfo%output,ForcePrint)
#ifdef VAR_MPI 
       lsmpibufferRIF12(26)=EV1b
#endif         

       !==============================================================
       != Term v2a: Vij^ab_v2a = Gijpq * Rpqab  G = r12^-1,  R = f12 =
       !==============================================================
       intspec(1) = 'D' !Auxuliary DF AO basis function on center 1 (2 empty)
       intspec(2) = 'R' !Regular AO basis function on center 3
       intspec(3) = 'R' !Regular AO basis function on center 4
       intspec(4) = 'C' !Regular Coulomb operator 1/r12
       intspec(5) = 'C' !The metric operator = Regular Coulomb operator 1/r12
       !Build the G coefficient of Eq. 90 of J Comput Chem 32: 2492–2513, 2011
       !Unique: CalphaR(NBA,nocv,nvirt)

       call Build_CalphaMO2(MyFragment%mylsitem,master,nbasis,nbasis,nAux,LUPRI,&
       & FORCEPRINT,wakeslaves,Cfull,nocvAOS,Cfull,nocvAOS,&
       & mynum,numnodesstd,CalphaR,NBA,ABdecompR,ABdecompCreateR,intspec,&
       & use_bg_buf,TensorTiling3C,NOMOTRANSVIRT)
       ABdecompCreateR = .FALSE.

       intspec(1) = 'D' !Auxuliary DF AO basis function on center 1 (2 empty)
       intspec(2) = 'R' !Regular AO basis function on center 3
       intspec(3) = 'R' !Regular AO basis function on center 4
       intspec(4) = 'G' !The Gaussian geminal operator g
       intspec(5) = 'G' !The Gaussian geminal operator g

       call Build_CalphaMO2(MyFragment%mylsitem,master,nbasis,nbasis,nAux,LUPRI,&
       & FORCEPRINT,wakeslaves,CoEOS,noccEOS,Cfull,nocvAOS,&
       & mynum,numnodesstd,CalphaG,NBA,ABdecompG,ABdecompCreateG,intspec,&
       & use_bg_buf,TensorTiling3C,NOMOTRANSVIRT)
       ABdecompCreateG = .FALSE.

       call F12RIUTIL_CCSDF12_V2a(nBA,noccEOS,nvirtAOS,nocvAOS,noccAOStot, &
               & CalphaR,CalphaG,Taibj,EV2a,wakeslaves,use_bg_buf,numnodesstd,&
               & nAuxMPI,mynum,Kval,noccpair)
       call LSTIMER('DEC-RICCSD(2)_/F12 V2a: ',TS2,TE2,DECinfo%output,ForcePrint)
#ifdef VAR_MPI 
       lsmpibufferRIF12(22)=EV2a
#endif

       !==============================================================
       != Term v3a+v4a: Vij^ab_v3a = Gijmc * Rmcab                   =
       !==============================================================
       intspec(1) = 'D' !Auxuliary DF AO basis function on center 1 (2 empty)
       intspec(2) = 'R' !Regular AO basis function on center 3
       intspec(3) = 'C' !CABS AO basis function on center 4
       intspec(4) = 'C' !The Coulomb Operator
       intspec(5) = 'C' !The Coulomb Operator
       !Unique: CalphaRcabsMO(NBA,ncabsMO,nocc)
       call Build_CalphaMO2(MyFragment%mylsitem,master,nbasis,ncabsAO,nAux,LUPRI,&
       & FORCEPRINT,wakeslaves,Cfull,nocvAOS,CMO_CABS,ncabsMO,&
       & mynum,numnodesstd,CalphaRcabsMO,NBA,ABdecompR,ABdecompCreateR,&
       & intspec,use_bg_buf,TensorTiling3C,NOMOTRANSVIRT)
       ABdecompCreateR = .FALSE.

       intspec(1) = 'D' !Auxuliary DF AO basis function on center 1 (2 empty)
       intspec(2) = 'R' !Regular AO basis function on center 3
       intspec(3) = 'C' !CABS AO basis function on center 4
       intspec(4) = 'G' !The Gaussian geminal operator g
       intspec(5) = 'G' !The Gaussian geminal operator g
       !Unique: CalphaGcabsMO(NBA,nocc,ncabsMO)
       call Build_CalphaMO2(MyFragment%mylsitem,master,nbasis,ncabsAO,nAux,&
            & LUPRI,FORCEPRINT,wakeslaves,CoEOS,noccEOS,CMO_CABS,ncabsMO,&
            & mynum,numnodesstd,CalphaGcabsMO,NBA,ABdecompG,ABdecompCreateG,&
            & intspec,use_bg_buf,TensorTiling3C,NOMOTRANSVIRT)
       ABdecompCreateG = .FALSE.
       
       call F12RIUTIL_CCSDF12_V3aV4a(nBA,noccEOS,nvirtAOS,nocvAOS,noccAOStot,ncabsMO,&
            & CalphaRcabsMO,CalphaGcabsMO,CalphaR,CalphaG,Taibj,EV3a,EV4a,&
            & wakeslaves,use_bg_buf,numnodesstd,nAuxMPI,mynum,Kval,noccpair)
       call LSTIMER('DEC-RICCSD(2)_/F12 V3aV4a: ',TS2,TE2,DECinfo%output,ForcePrint)
#ifdef VAR_MPI 
       lsmpibufferRIF12(23)=EV3a
       lsmpibufferRIF12(24)=EV4a
#endif         
       
       !==============================================================
       != Term C-term: Cij^ab = Xijab + Xjiba                        =
       !==============================================================

       m = NBA*noccEOS
       k = ncabsMO         ! T_ia = A_ic F_ac^T
       n = nvirtAOS
       nsize = nBA*noccEOS*nvirtAOS
       call mem_alloc(CalphaTmp3, nsize)
       call dgemm('N','T',m,n,k,1.0E0_realk,CalphaGcabsMO,m,Fac,n,0.0E0_realk,CalphaTmp3,m)
       call F12RIUTIL_CCSDF12_C1aC2a(nBA,noccEOS,nvirtAOS,nocvAOS,noccAOStot &
            & ,CalphaG,CalphaTmp3,Taibj,EC1a2a,Kval,noccpair)       
       call mem_dealloc(CalphaTmp3)
       call LSTIMER('DEC-RICCSD(2)_/F12 Cijab: ',TS2,TE2,DECinfo%output,ForcePrint)
#ifdef VAR_MPI 
       lsmpibufferRIF12(25)=EC1a2a
#endif  

       !==============================================================
       != Term v2b: Vij^ia_2b = Fijia                                =
       !==============================================================
       call F12RIUTIL_CCSDF12_V2b(NBA,offset,noccEOS,nvirtAOS,nocvAOS,noccAOStot,CalphaR,&
            & CalphaG,Tai,EV2b,wakeslaves,use_bg_buf,numnodesstd,nAuxMPI,mynum) 
       call LSTIMER('DEC-RICCSD(2)_/F12 V2b: ',TS2,TE2,DECinfo%output,ForcePrint)
#ifdef VAR_MPI 
       lsmpibufferRIF12(27)=EV2b      !we need to perform a MPI reduction at the end 
#endif

       !==============================================================
       != Term v3b+v4b: Vij^ia_v3bv4b = Gijmc * Rmcia                =
       !==============================================================

       call F12RIUTIL_CCSDF12_V3bV4b(nBA,offset,noccEOS,nvirtAOS,nocvAOS,noccAOStot,ncabsMO,&
            & CalphaRcabsMO,CalphaGcabsMO,CalphaR,CalphaG,Tai,EV3b,EV4b,&
            & wakeslaves,use_bg_buf,numnodesstd,nAuxMPI,mynum,Kval,noccpair)
       call LSTIMER('DEC-RICCSD(2)_/F12 V3bV4b: ',TS2,TE2,DECinfo%output,ForcePrint)
#ifdef VAR_MPI 
       lsmpibufferRIF12(28)=EV3b      !we need to perform a MPI reduction at the end 
       lsmpibufferRIF12(29)=EV4b      !we need to perform a MPI reduction at the end 
#endif
       
       call mem_dealloc(CalphaR)
       call mem_dealloc(CalphaG)
       call mem_dealloc(CalphaRcabsMO)
       call mem_dealloc(CalphaGcabsMO)
       
       call LSTIMER('START DEC-RICCSD(2)_/F12: ',TS,TE,DECinfo%output,ForcePrint)
    endif !CCSD contributions
    call mem_dealloc(ABdecompG)
    call mem_dealloc(ABdecompX)
    call mem_dealloc(ABdecompF)
    call mem_dealloc(ABdecompR)

    call mem_dealloc(Kval)
    call mem_dealloc(Kvalnoperm)

#ifdef VAR_MPI
    nbuf1 = 30
    CALL lsmpi_reduction(lsmpibufferRIF12,nbuf1,infpar%master,infpar%lg_comm)

    EB1=lsmpibufferRIF12(1)
    EV1=lsmpibufferRIF12(2)
    EX1=lsmpibufferRIF12(3)
    EB2=lsmpibufferRIF12(4)
    EB3=lsmpibufferRIF12(5)
    EV2=lsmpibufferRIF12(6)
    EX2=lsmpibufferRIF12(7)
    EV3=lsmpibufferRIF12(8)
    EV4=lsmpibufferRIF12(9)
    EC1C2=lsmpibufferRIF12(10)
    EX3=lsmpibufferRIF12(11)
    EX4=lsmpibufferRIF12(12)
    EB4=lsmpibufferRIF12(13)
    EB5=lsmpibufferRIF12(14)
    EB6=lsmpibufferRIF12(15)
    !for some reason missing 16
    EB7=lsmpibufferRIF12(17)
    EB8=lsmpibufferRIF12(18)
    EB9=lsmpibufferRIF12(19)

    EV1a=lsmpibufferRIF12(21)
    EV2a=lsmpibufferRIF12(22)
    EV3a=lsmpibufferRIF12(23)
    EV4a=lsmpibufferRIF12(24)

    EC1a2a=lsmpibufferRIF12(25)

    EV1b=lsmpibufferRIF12(26)
    EV2b=lsmpibufferRIF12(27)
    EV3b=lsmpibufferRIF12(28)
    EV4b=lsmpibufferRIF12(29)
#endif

    E_21 = EV1 + EV2 + EV3 + EV4 
    E_22 = EX1 + EX2 + EX3 + EX4 
    E_23 = EB1 + EB2 + EB3 + EB4 + EB5 + EB6 + EB7 + EB8 + EB9
    E_MP2F12_geminal = E_21+E_22+E_23

    IF(DoCCSD)THEN
       EVa = EV1a + EV2a + EV3a + EV4a
       EVb = EV1b + EV2b + EV3b + EV4b
       EVc = EVb 
       
       E_CCSDF12 = EVa + EVb + EVc + EC1a2a
    ENDIF

    !WARNING THE C coupling term E_21C E(CC,RI) is handled outside this routine. 
    !   E_21C=lsmpibufferRIF12(20)

    IF(master.AND.DoPrint)THEN
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(V1,RI) = ', EV1
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(X1,RI) = ', EX1
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(B1,RI) = ', EB1
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(B2,RI) = ', EB2
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(B3,RI) = ', EB3
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(V2,RI) = ', EV2
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(X2,RI) = ', EX2
       !WARNING THE C coupling term E_21C E(CC,RI) is handled outside this routine. 
       !      IF(DECinfo%F12Ccoupling)THEN 
       !         WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(CC,RI) = ', E_21C 
       !      ENDIF
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(V3,RI) = ', EV3
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(V4,RI) = ', EV4
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(V5,RI) = ', EC1C2
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(X3,RI) = ', EX3
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(X4,RI) = ', EX4
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(B4,RI) = ', EB4
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(B5,RI) = ', EB5
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(B6,RI) = ', EB6
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(B7,RI) = ', EB7
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(B8,RI) = ', EB8
       WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC RIMP2F12 Energy contribution: E(B9,RI) = ', EB9
       IF(DoCCSD)THEN
          WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC CCSD(2)_F12 Energy cont:      EV1a     = ', EV1a
          WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC CCSD(2)_F12 Energy cont:      EV1b     = ', EV1b
          WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC CCSD(2)_F12 Energy cont:      EV2a     = ', EV2a
          WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC CCSD(2)_F12 Energy cont:      EV2b     = ', EV2b
          WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC CCSD(2)_F12 Energy cont:      EV3a     = ', EV3a
          WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC CCSD(2)_F12 Energy cont:      EV4a     = ', EV4a
          WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC CCSD(2)_F12 Energy cont:      EV3b     = ', EV3b
          WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC CCSD(2)_F12 Energy cont:      EV4b     = ', EV4b
          WRITE(DECINFO%OUTPUT,'(4X,A,F20.13)')'DEC CCSD(2)_F12 Energy cont:      EC1C2    = ', EC1a2a
       ENDIF

       write(DECinfo%output,'(1X,a)') '----------------------------------------'
       write(DECinfo%output,'(1X,a)') ' E21 V term                             '
       write(DECinfo%output,'(1X,a)') '----------------------------------------'
       !WARNING THE C coupling term E_21C E(CC,RI) is handled outside this routine. 
       !write(DECinfo%output,'(1X,a,g25.16)') " E21_CC_term: ", E_21C
       write(DECinfo%output,'(1X,a,g25.16)') " E21_V_term1:    ", EV1
       write(DECinfo%output,'(1X,a,g25.16)') " E21_V_term2:    ", EV2
       write(DECinfo%output,'(1X,a,g25.16)') " E21_V_term3:    ", EV3
       write(DECinfo%output,'(1X,a,g25.16)') " E21_V_term4:    ", EV4
       write(DECinfo%output,'(1X,a,g25.16)') " E21_C1C2_term:  ", EC1C2
       write(DECinfo%output,'(1X,a)') '----------------------------------------'
       write(DECinfo%output,'(1X,a,g25.16)') " E21_Vsum:       ", E_21+EC1C2!+E_21C   
       write(DECinfo%output,'(1X,a)') "----------------------------------------"
       write(DECinfo%output,'(1X,a)') " E_22 X term                            "
       write(DECinfo%output,'(1X,a)') "----------------------------------------"
       write(DECinfo%output,'(1X,a,g25.16)') " E22_X_term1:    ", EX1
       write(DECinfo%output,'(1X,a,g25.16)') " E22_X_term2:    ", EX2
       write(DECinfo%output,'(1X,a,g25.16)') " E22_X_term3:    ", EX3
       write(DECinfo%output,'(1X,a,g25.16)') " E22_X_term4:    ", EX4
       write(DECinfo%output,'(1X,a)') '----------------------------------------'
       write(DECinfo%output,'(1X,a,g25.16)') " E22_Xsum:       ", E_22      
       write(DECinfo%output,'(1X,a)') '----------------------------------------'
       write(DECinfo%output,*) ' E_22 B term                            '
       write(DECinfo%output,'(1X,a)') '----------------------------------------'
       write(DECinfo%output,'(1X,a,g25.16)') " E23_B_term1:    ", EB1
       write(DECinfo%output,'(1X,a,g25.16)') " E23_B_term2:    ", EB2   
       write(DECinfo%output,'(1X,a,g25.16)') " E23_B_term3:    ", EB3  
       write(DECinfo%output,'(1X,a,g25.16)') " E23_B_term4:    ", EB4   
       write(DECinfo%output,'(1X,a,g25.16)') " E23_B_term5:    ", EB5   
       write(DECinfo%output,'(1X,a,g25.16)') " E23_B_term6:    ", EB6   
       write(DECinfo%output,'(1X,a,g25.16)') " E23_B_term7:    ", EB7  
       write(DECinfo%output,'(1X,a,g25.16)') " E23_B_term8:    ", EB8  
       write(DECinfo%output,'(1X,a,g25.16)') " E23_B_term9:    ", EB9   
       write(DECinfo%output,'(1X,a)') '----------------------------------------'
       write(DECinfo%output,'(1X,a,g25.16)') " E23_Bsum:       ", E_23
       if(DoCCSD)THEN
          write(DECinfo%output,'(1X,a)')'----------------------------------------'        
          write(DECinfo%output,'(1X,a)')' E21 CCSD Viajb-terms         ' 
          write(DECinfo%output,'(1X,a)')'----------------------------------------' 
          write(DECinfo%output,'(1X,a,g25.16)')' E21_Viajb_term1: ', EV1a
          write(DECinfo%output,'(1X,a,g25.16)')' E21_Viajb_term2: ', EV2a
          write(DECinfo%output,'(1X,a,g25.16)')' E21_Viajb_term3: ', EV3a
          write(DECinfo%output,'(1X,a,g25.16)')' E21_Viajb_term4: ', EV4a
          write(DECinfo%output,'(1X,a,g25.16)')' E21_Ciajb_term1: ', EC1a2a
          write(DECinfo%output,'(1X,a)')'----------------------------------------' 
          write(DECinfo%output,'(1X,a,g25.16)')' sum            : ', EV1a+EV2a+EV3a+EV4a+EC1a2a
          write(DECinfo%output,'(1X,a)')'----------------------------------------' 
          write(DECinfo%output,'(1X,a,g25.16)')' E21 CCSD Viija_terms '
          write(DECinfo%output,'(1X,a)')'----------------------------------------'
          write(DECinfo%output,'(1X,a,g25.16)')' E21_Viija_term1: ', EV1b 
          write(DECinfo%output,'(1X,a,g25.16)')' E21_Viija_term2: ', EV2b 
          write(DECinfo%output,'(1X,a,g25.16)')' E21_Viija_term3: ', EV3b 
          write(DECinfo%output,'(1X,a,g25.16)')' E21_Viija_term4: ', EV4b 
          write(DECinfo%output,'(1X,a)')'----------------------------------------'
          write(DECinfo%output,'(1X,a,g25.16)')' sum            : ', EV1b+EV2b+EV3b+EV4b 
          write(DECinfo%output,'(1X,a)')'----------------------------------------'
          write(DECinfo%output,'(1X,a,g25.16)')'  E21 CCSD Viajj_terms '
          write(DECinfo%output,'(1X,a)')'----------------------------------------'
          write(DECinfo%output,'(1X,a,g25.16)')'E21_Viajj_term1: ', EV1b
          write(DECinfo%output,'(1X,a,g25.16)')'E21_Viajj_term2: ', EV2b
          write(DECinfo%output,'(1X,a,g25.16)')'E21_Viajj_term3: ', EV4b
          write(DECinfo%output,'(1X,a,g25.16)')'E21_Viajj_term4: ', EV3b
          write(DECinfo%output,'(1X,a)')'----------------------------------------'
          write(DECinfo%output,'(1X,a,g25.16)')'sum            : ', EV1b + EV2b + EV3b + EV4b 
          write(DECinfo%output,'(1X,a)')'----------------------------------------'        
          write(DECinfo%output,'(1X,a,g25.16)')'      CCSD(2)_F12 Correction  Summary   ' 
          write(DECinfo%output,'(1X,a)')'----------------------------------------' 
          write(DECinfo%output,'(1X,a,f20.10)') 'E_MP2-F12(geminal)    : ', E_MP2F12_geminal
          write(DECinfo%output,'(1X,a,f20.10)') 'Delta E_CCSD(2)_F12   : ', E_CCSDF12 
          write(DECinfo%output,'(1X,a,g25.16)')'----------------------------------------'
          write(DECinfo%output,'(1X,a,f20.10)') 'E_corr CCSDF12(2)_F12 : ', E_MP2F12_geminal + E_CCSDF12 
          write(DECinfo%output,'(1X,a,g25.16)')'----------------------------------------'     
       endif
    endif

    IF(.NOT.DoCCSD)THEN

       E_F12 = E_21 + E_22 + E_23 + EC1C2

       if(DoPrint .AND. master) then
          !> MP2-energy from an MP2-calculation
          RIMP2_energy = Myfragment%energies(FRAGMODEL_OCCRIMP2)
          write(DECinfo%output,'(1X,a)') '----------------------------------------------------------------'
          write(DECinfo%output,'(1X,a)') '                  DEC-RI-MP2-F12 CALCULATION                    '
          write(DECinfo%output,'(1X,a)') '----------------------------------------------------------------'
          write(DECinfo%output,'(1X,a,f20.10)') ' RI-MP2 CORRELATION ENERGY (For DEC) = ', RIMP2_energy
          write(DECinfo%output,'(1X,a,f20.10)') ' F12 E21 CORRECTION TO ENERGY =        ', E_21
          write(DECinfo%output,'(1X,a,f20.10)') ' F12 E22 CORRECTION TO ENERGY =        ', E_22
          write(DECinfo%output,'(1X,a,f20.10)') ' F12 E23 CORRECTION TO ENERGY =        ', E_23
          write(DECinfo%output,'(1X,a,f20.10)') ' F12 CORRECTION TO ENERGY =            ', E_F12
          write(DECinfo%output,'(1X,a,f20.10)') ' MP2-F12 CORRELATION ENERGY (DEC) =    ', RIMP2_energy+E_F12
       endif
       !> Setting the MP2-F12 correction
       Myfragment%energies(FRAGMODEL_RIMP2f12) = E_F12
    ELSE
       E_MP2F12_geminal = E_21 + E_22 + E_23
       EC1C2 = 0.0E0_realk
       EVa = EV1a + EV2a + EV3a + EV4a
       EVb = EV1b + EV2b + EV3b + EV4b
       EVc = EVb 
       E_CCSDF12 = EVa + EVb + EVc + EC1a2a
       E_F12 = E_MP2F12_geminal + E_CCSDF12 
       if(DoPrint .AND. master) then
          !> CCSD-energy from an CCSD-calculation
          CCSD_energy = Myfragment%energies(FRAGMODEL_OCCCCSD)
          write(DECinfo%output,'(1X,a)') '----------------------------------------------------------------'
          write(DECinfo%output,'(1X,a)') '                  DEC-CCSD-F12 CALCULATION (F12 uses RI)        '
          write(DECinfo%output,'(1X,a)') '----------------------------------------------------------------'
          write(DECinfo%output,'(1X,a,f20.10)') ' CCSD CORRELATION ENERGY (For DEC) =   ', CCSD_energy
          write(DECinfo%output,'(1X,a,f20.10)') ' MP2-F12 GEMINAL CORRECTION        =   ', E_MP2F12_geminal
          write(DECinfo%output,'(1X,a,f20.10)') ' CCSD-F12 CORRECTION               =   ', E_CCSDF12 
          write(DECinfo%output,'(1X,a,f20.10)') ' TOTAL F12 CORRECTION TO ENERGY    =   ', E_F12
          write(DECinfo%output,'(1X,a,f20.10)') ' CCSD-F12 CORRELATION ENERGY (DEC) =   ', CCSD_energy+E_F12
       endif
       !> Setting the CCSD(2)_F12 correction
       Myfragment%energies(FRAGMODEL_RICCSDF12) = E_F12
    ENDIF

    !> Deallocate
    call mem_dealloc(nAuxMPI)

    IF(DECinfo%FullCabsAtomicExtent)THEN
       MyFragment%Mylsitem%setting%sameMol = SavesameMol
    ENDIF

    call mem_dealloc(Cfull)
    call mem_dealloc(CoEOS)
    call mem_dealloc(CoAOS)
    call mem_dealloc(CoAOStot)
    call mem_dealloc(CvAOS)

    call mem_dealloc(Fac)
    call mem_dealloc(Fpp)
    call mem_dealloc(Fkj)
    call mem_dealloc(Fnm)

    call mem_dealloc(CMO_CABS)
    call mem_dealloc(CMO_RI)
    call mem_dealloc(dopair_occ)

  end subroutine get_rif12_fragment_energy

  subroutine BuildKval(dopair_occ,noccEOS,Kval,noccpair,dopair,&
       & KVALnoperm,noccpairnoperm)
    implicit none
    integer,intent(in) :: noccEOS
    logical,intent(in) :: dopair_occ(noccEOS,noccEOS),dopair
    integer,pointer    :: KVAL(:,:),KVALnoperm(:,:)
    integer,intent(inout) :: noccpair,noccpairnoperm
    !local variables
    integer :: nK,J,I
    IF(dopair)THEN
       noccpair=COUNT(dopair_occ)/2
       call mem_alloc(KVALnoperm,3,noccpair*2)
       noccpairnoperm=noccpair*2
    ELSE
       nK=NINT(SQRT(real(COUNT(dopair_occ))))
       noccpair=(nK*(nK+1))/2
       call mem_alloc(KVALnoperm,3,noccEOS*noccEOS)
       noccpairnoperm=noccEOS*noccEOS
    ENDIF
    call mem_alloc(KVAL,3,noccpair)
    nK=0
    DO j=1,noccEOS 
       IF(dopair_occ(J,J)) THEN
          nK=nK+1
          KVAL(1,nK)=J
          KVAL(2,nK)=J
          KVAL(3,nK)=1.0E0_realk
       ENDIF
       DO i=j+1,noccEOS 
          IF(dopair_occ(I,J)) THEN
             nK=nK+1
             KVAL(1,nK)=I
             KVAL(2,nK)=J
             KVAL(3,nK)=2.0E0_realk
          ENDIF
       ENDDO
    ENDDO
    IF(nK.NE.noccpair)call lsquit('BuildKval: nK.NE.noccpair',-1)
    nK=0
    DO j=1,noccEOS
       DO i=1,noccEOS
          IF(dopair_occ(I,J)) THEN
             nK=nK+1
             Kvalnoperm(1,nK) = i 
             Kvalnoperm(2,nK) = j
             Kvalnoperm(3,nK) = 1.0E0_realk
          ENDIF
       ENDDO
    ENDDO
  end subroutine BuildKval
  
end module rif12_integrals_module

subroutine get_rif12_fragment_energy_slave()
   use rif12_integrals_module
#ifdef VAR_MPI   
   use infpar_module
   use lsmpi_type
#endif
   use precision
   use dec_typedef_module
   !use memory_handling
   use lsparameters
   ! *********************************************
   !   DEC DEPENDENCIES (within deccc directory) 
   ! *********************************************
#ifdef VAR_MPI
   use decmpi_module !, only: mpi_communicate_mp2_int_and_amp
#endif
   implicit none

  !> Atomic fragment to be determined (Single or Pair fragment)
   type(decfrag) :: MyFragment
   !> t2EOS amplitudes stored in the order T(a,i,b,j)
   real(realk), pointer :: Taibj(:,:,:,:)
   !> t1EOS amplitudes stored in the order T(a,i)
   real(realk), pointer :: Tai(:,:)
   !> Case MODEL
   integer :: fragcase
   !> Fragment 1 in the pair fragment
   type(decfrag) :: Fragment1
   !> Fragment 2 in the pair fragment
   type(decfrag) :: Fragment2
   !> Logical variable to check if this is a pair fragment
   logical :: dopair
#ifdef VAR_MPI
   call mpi_communicate_MyFragment_f12(MyFragment,Taibj,fragcase,dopair)
   if(dopair) then
      call get_rif12_fragment_energy(MyFragment, Taibj, Tai, fragcase, Fragment1, Fragment2) 
   else
      call get_rif12_fragment_energy(MyFragment, Taibj, Tai, fragcase)
   endif
#endif

end subroutine get_rif12_fragment_energy_slave
